#include "mainwindow.h"
#include "ui_mainwindow.h"

double xmin,xmax,ymin,ymax;
double epsilon;


MainWindow::MainWindow(QWidget *parent) :  QMainWindow(parent),
      ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    xmin=-5;xmax=5;
    ymin=-5;ymax=5;
     ui->graphicsView->setInteractive(true);
    R=new repere(this,ui->graphicsView,xmin,xmax,ymin,ymax);
}

void MainWindow::Init()
{ epsilon=ui->EpsilonSpinBox->value();
}

MainWindow::~MainWindow()
{
    delete ui;
}

iboolean Inside (box& X)
{   interval F1=Sqr(X[1])+Sqr(X[2])+Sin(X[1]+X[2]);
    iboolean T1=In(F1,interval(4,9));
    return (T1);
};

void MainWindow::on_ButtonStart_clicked()
{     Init();
      list<box> L;
      int k=0;
      box X(interval(xmin,xmax),interval(ymin,ymax));
      L.push_back (X);
      while ( !L.empty() )
      {   k++;
          X=L.front();   L.pop_front();
          iboolean test=Inside (X);
          if (X.Width()<epsilon)     R->DrawBox(X[1].inf,X[1].sup,X[2].inf,X[2].sup,QPen(Qt::yellow),QBrush(Qt::white));
          else if ( test==itrue )    R->DrawBox(X[1].inf,X[1].sup,X[2].inf,X[2].sup,QPen(Qt::darkRed),QBrush(Qt::red));
          else if (test==ifalse)     R->DrawBox(X[1].inf,X[1].sup,X[2].inf,X[2].sup,QPen(Qt::darkBlue),QBrush(Qt::cyan));
          else
          {   box X1(2);  box X2(2);
              Bisect (X,X1,X2);
              L.push_back(X1);  L.push_back(X2);
          }
      }
      qDebug() << "Number of boxes "<<k;
      R->Save("paving");
}
